<?php

$pagePath = explode('/wp-content/', dirname(__FILE__));
require_once($pagePath[0] . '/wp-load.php');

function get_providers_method() {
	$providers_api = [];
	$providers_api = apply_filters('cp_get_providers', $providers_api);

	if (!isset($providers_api['error'])) {
		$providers_db = get_option('cp_payment_providers');
		$default_checkbox_value = 'yes';

		if (empty($providers_db)) {
			$providers_db = [];

			foreach ($providers_api as $provider) {
				$wc_provider_id = 'woocommerce_cp_payment_gateway_provider_' . $provider['id'];

				$statusObj = [
					'availability' => $provider['status']['availability'],
					'retryAt' => $provider['status']['retryAt'],
					'lastUpdatedAt' => $provider['status']['lastUpdatedAt'],
				];
				$presentationObj = [
					'priority' => $provider['presentation']['priority'],
					'color' => $provider['presentation']['color'],
					'logo' => $provider['presentation']['logo'],
				];

				$new_or_updated_provider = [
					'id' => $provider['id'],
					'name' => $provider['name'],
					'countryCode' => $provider['countryCode'],
					'identificationCodes' => $provider['identificationCodes'],
					'bic' => $provider['bic'],
					'status' => $statusObj,
					'presentation' => $presentationObj,
					'checked' => $default_checkbox_value
				];

				$providers_db[$wc_provider_id] = $new_or_updated_provider;
			}

			update_option('cp_payment_providers', $providers_db);

			$redirect_url = get_admin_url() . 'admin.php?page=wc-settings&tab=checkout&section=cp_payment_gateway&providersupdate=success';
		} else {
			// Check if any providers were removed
			foreach ($providers_db as $key => $provider) {
				$exists = false;
				foreach ($providers_api as $provider_api) {
					$id = $provider['id'];
					$exists = in_array($id, $provider_api);

					if ($exists) {
						break;
					}
				}

				if (!$exists) {
					unset($providers_db[$key]);
				}
			}

			foreach ($providers_api as $provider) {
				$wc_provider_id = 'woocommerce_cp_payment_gateway_provider_' . $provider['id'];

				$statusObj = [
					'availability' => $provider['status']['availability'],
					'retryAt' => $provider['status']['retryAt'],
					'lastUpdatedAt' => $provider['status']['lastUpdatedAt'],
				];
				$presentationObj = [
					'priority' => $provider['presentation']['priority'],
					'color' => $provider['presentation']['color'],
					'logo' => $provider['presentation']['logo'],
				];

				$new_or_updated_provider = [
					'id' => $provider['id'],
					'name' => $provider['name'],
					'countryCode' => $provider['countryCode'],
					'identificationCodes' => $provider['identificationCodes'],
					'bic' => $provider['bic'],
					'status' => $statusObj,
					'presentation' => $presentationObj,
					'checked' => $default_checkbox_value
				];

				if (array_key_exists($wc_provider_id, $providers_db)) {
					$new_or_updated_provider['checked'] = $providers_db[$wc_provider_id]['checked'];
				}

				$providers_db[$wc_provider_id] = $new_or_updated_provider;
			}

			update_option('cp_payment_providers', $providers_db);
			$redirect_url = get_admin_url() . 'admin.php?page=wc-settings&tab=checkout&section=cp_payment_gateway&providersupdate=success';
		}
	} else {
		$redirect_url = get_admin_url() . 'admin.php?page=wc-settings&tab=checkout&section=cp_payment_gateway&providersupdate=failed';
	}

	wp_redirect($redirect_url);
	exit;
}

function update_last_update_time() {
	$date = new DateTime();
	$current_date = $date->format('Y-m-d H:i:s');
	update_option('cp_last_update', $current_date);
}

update_last_update_time();
get_providers_method();
